/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore', {
  extend : 'Ext.data.TreeStore',

  requires : [
    'QDesk.model.gui.JSScriptingTreeNode'
  ],

  model : 'QDesk.model.gui.JSScriptingTreeNode',

  defaultRootText : '',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    var root = {
      children : [
        /* FixedTimePeriod type */
        {
          propertyName : 'FixedTimePeriod',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod' ),
          leaf : false,
          children : [
            {
              propertyName : 'length',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.length' ),
              leaf : true
            },
            {
              propertyName : 'firstWeekDay',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.firstWeekDay' ),
              leaf : true
            },
            {
              propertyName : 'from',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.from' ),
              leaf : true
            },
            {
              propertyName : 'to',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.to' ),
              leaf : true
            }
          ]
        },

        /* QuartzExecHistory type */
        {
          propertyName : 'QuartzExecHistory',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory' ),
          leaf : false,
          children : [
            {
              propertyName : 'id',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.id' ),
              leaf : true
            },
            {
              propertyName : 'startedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.startedAt' ),
              leaf : true
            },
            {
              propertyName : 'finishedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.finishedAt' ),
              leaf : true
            },
            {
              propertyName : 'duration',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.duration' ),
              leaf : true
            },
            {
              propertyName : 'execStatus',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.execStatus' ),
              leaf : true
            },
            {
              propertyName : 'execType',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.execType' ),
              leaf : true
            },

            /* Scheduler info */
            {
              propertyName : 'schedulerObjectName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerObjectName' ),
              leaf : true
            },
            {
              propertyName : 'schedulerVersion',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerVersion' ),
              leaf : false,
              children : [
                {
                  propertyName : 'major',
                  propertyType : 'Number',
                  description : QDesk.Msg.get(
                      'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerVersion.major' ),
                  leaf : true
                },
                {
                  propertyName : 'minor',
                  propertyType : 'Number',
                  description : QDesk.Msg.get(
                      'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerVersion.minor' ),
                  leaf : true
                },
                {
                  propertyName : 'maintenance',
                  propertyType : 'Number',
                  description : QDesk.Msg.get(
                      'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerVersion.maintenance' ),
                  leaf : true
                }
              ]
            },
            {
              propertyName : 'schedulerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerName' ),
              leaf : true
            },
            {
              propertyName : 'schedulerInstanceId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerInstanceId' ),
              leaf : true
            },

            /* Job info */
            {
              propertyName : 'jobClassName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobClassName' ),
              leaf : true
            },
            {
              propertyName : 'jobClassLocation',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobClassLocation' ),
              leaf : true
            },
            {
              propertyName : 'jobGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobGroupName' ),
              leaf : true
            },
            {
              propertyName : 'jobName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobName' ),
              leaf : true
            },
            {
              propertyName : 'jobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobDataMap' ),
              leaf : true
            },
            {
              propertyName : 'triggerGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.triggerGroupName' ),
              leaf : true
            },
            {
              propertyName : 'triggerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.triggerName' ),
              leaf : true
            },
            {
              propertyName : 'calendarName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.calendarName' ),
              leaf : true
            },

            /* Blobs */
            {
              propertyName : 'result',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.result' ),
              leaf : true
            },
            {
              propertyName : 'userData',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.userData' ),
              leaf : true
            },
            {
              propertyName : 'error',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.error' ),
              leaf : true
            },
            {
              propertyName : 'log',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.log' ),
              leaf : true
            },

            /* Thread info */
            {
              propertyName : 'threadGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.threadGroupName' ),
              leaf : true
            },
            {
              propertyName : 'threadName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.threadName' ),
              leaf : true
            },
            {
              propertyName : 'threadPriority',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.threadPriority' ),
              leaf : true
            },

            /* Host info */
            {
              propertyName : 'hostName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.hostName' ),
              leaf : true
            },

            /* JVM info */
            {
              propertyName : 'jvmPid',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jvmPid' ),
              leaf : true
            },
            {
              propertyName : 'jvmName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jvmName' ),
              leaf : true
            },
            {
              propertyName : 'jvmVendor',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jvmVendor' ),
              leaf : true
            },
            {
              propertyName : 'jvmVersion',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jvmVersion' ),
              leaf : true
            },
            {
              propertyName : 'jvmRuntimeVersion',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jvmRuntimeVersion' ),
              leaf : true
            },

            /* OS info */
            {
              propertyName : 'osName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.osName' ),
              leaf : true
            },
            {
              propertyName : 'osArch',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.osArch' ),
              leaf : true
            },

            /* Job chain related attributes */
            {
              propertyName : 'jobChainId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobChainId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainFlowId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobChainFlowId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainSrcExecHistoryId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobChainSrcExecHistoryId' ),
              leaf : true
            }
          ]
        },

        /* QuartzExecStatData */
        {
          propertyName : 'QuartzExecStatData',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData' ),
          leaf : false,
          children : [
            {
              propertyName : 'periodStart',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodStart' ),
              leaf : true
            },
            {
              propertyName : 'periodEnd',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodEnd' ),
              leaf : true
            },
            {
              propertyName : 'periodLength',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodLength' ),
              leaf : true
            },
            {
              propertyName : 'complete',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.complete' ),
              leaf : true
            },

            {
              propertyName : 'jobGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.jobGroupName' ),
              leaf : true
            },
            {
              propertyName : 'jobName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.jobName' ),
              leaf : true
            },

            {
              propertyName : 'triggerGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.triggerGroupName' ),
              leaf : true
            },
            {
              propertyName : 'triggerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.triggerName' ),
              leaf : true
            },

            {
              propertyName : 'countSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countSuccess' ),
              leaf : true
            },
            {
              propertyName : 'countVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countVeto' ),
              leaf : true
            },
            {
              propertyName : 'countError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countError' ),
              leaf : true
            },
            {
              propertyName : 'countSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countSuccessAndError' ),
              leaf : true
            },

            {
              propertyName : 'timeSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeSuccess' ),
              leaf : true
            },
            {
              propertyName : 'timeVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeVeto' ),
              leaf : true
            },
            {
              propertyName : 'timeError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeError' ),
              leaf : true
            },
            {
              propertyName : 'timeSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeSuccessAndError' ),
              leaf : true
            },

            {
              propertyName : 'avgTimeSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeSuccess' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeVeto' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeError' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeSuccessAndError' ),
              leaf : true
            }
          ]
        }
      ]
    };

    Ext.apply( config, {
      root : root
    } );

    me.callParent( [ config ] );
  }
} )
;
