/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * QDesk configuration singleton that encapsulates action URLs.
 */
Ext.define( 'QDesk.util.constant.ActionUrl', {

  singleton : true,

  /*
   * Common actions
   */
  emptyStoreAction : 'common/extjs/EmptyStore.action',


  /*
   * Uncategorized actions
   */
  aboutActionData : 'About.action?data=',

  heartbeatAction : 'Heartbeat.action?heartbeat=',

  imageActionCheck : 'Image.action?check=',

  svgActionPrepare : 'SaveSvg.action?prepare=',
  svgActionDownload : 'SaveSvg.action?download=',


  saveLogActionPrepare : 'SaveLog.action?prepare=',
  saveLogActionDownload : 'SaveLog.action?download=',

  /*
   * Config actions
   */
  applicationConfigActionSaveChanges : 'config/ApplicationConfig.action?saveChanges=',
  applicationConfigActionSaveGridConfig : 'config/ApplicationConfig.action?saveGridConfig=',

  connectionConfigActionSaveChanges : 'config/ConnectionConfig.action?saveChanges=',
  connectionConfigActionSaveGridConfig : 'config/ConnectionConfig.action?saveGridConfig=',

  /*
   * User actions
   */
  userActionList : 'security/User.action?list=',
  userActionAdd : 'security/User.action?add=',
  userActionUpdate : 'security/User.action?update=',
  userActionGet : 'security/User.action?get=',
  userActionDefaults : 'security/User.action?defaults=',
  userActionDelete : 'security/User.action?delete=',
  userActionLock : 'security/User.action?lock=',
  userActionUnlock : 'security/User.action?unlock=',
  userActionGetEffectivePermissions : 'security/User.action?getEffectivePermissions=',
  userActionUpdateProfile : 'security/User.action?updateProfile=',

  /*
   * Group actions
   */
  groupActionList : 'security/Group.action?list=',
  groupActionListMembers : 'security/Group.action?listMembers=',
  groupActionAdd : 'security/Group.action?add=',
  groupActionUpdate : 'security/Group.action?update=',
  groupActionGet : 'security/Group.action?get=',
  groupActionDefaults : 'security/Group.action?defaults=',
  groupActionDelete : 'security/Group.action?delete=',


  /*
   * Connection actions
   */
  connectionActionTree : 'connection/ConnectionTree.action?tree=',

  // connection actions
  connectionManagementActionAddConnection : 'connection/ConnectionManagement.action?addConnection=',
  connectionManagementActionGetConnection : 'connection/ConnectionManagement.action?getConnection=',
  connectionManagementActionUpdateConnection : 'connection/ConnectionManagement.action?updateConnection=',
  connectionManagementActionDeleteConnection : 'connection/ConnectionManagement.action?deleteConnection=',
  connectionManagementActionMoveConnection : 'connection/ConnectionManagement.action?moveConnection=',
  connectionManagementActionGetDefaultConnectionConfig : 'connection/ConnectionManagement.action?getDefaultConnectionConfig=',

  // folder actions
  connectionManagementActionAddFolder : 'connection/ConnectionManagement.action?addFolder=',
  connectionManagementActionUpdateFolder : 'connection/ConnectionManagement.action?updateFolder=',
  connectionManagementActionDeleteFolder : 'connection/ConnectionManagement.action?deleteFolder=',
  connectionManagementActionMoveFolder : 'connection/ConnectionManagement.action?moveFolder=',

  connectionManagementActionStartAll : 'connection/ConnectionManagement.action?startAll=',
  connectionManagementActionPauseAll : 'connection/ConnectionManagement.action?pauseAll=',
  connectionManagementActionStopAll : 'connection/ConnectionManagement.action?stopAll=',


  /*
   * Customization actions
   */
  customizationGuiGetNavigationPanelDefinition : 'customization/gui/NavigationPanel.action?getDefinition=',


  /*
   * License actions
   */
  licenseActionV10Info : 'license/v1_0/License.action?info=',
  licenseActionV10GeneralInfoTree : 'license/v1_0/License.action?generalInfoTree=',
  licenseActionV10FeaturesInfoTree : 'license/v1_0/License.action?featuresInfoTree=',


  /*
   * Locale actions
   */
  localeActionLocales : 'locale/Locale.action?locales=',
  localeActionSwitch : 'locale/Locale.action?switch=',


  /*
   * Message actions
   */
  messageActionListForCreator : 'message/Message.action?listForCreator=',
  messageActionDownloadAttachment : 'message/Message.action?downloadAttachment=',

  // message channel actions
  messageChannelActionTest : 'message/MessageChannel.action?test=',

  // message channel profile action
  messageChannelProfileActionTree : 'message/MessageChannelProfile.action?tree=',
  messageChannelProfileActionGetProfile : 'message/MessageChannelProfile.action?getProfile=',
  messageChannelProfileActionAddProfile : 'message/MessageChannelProfile.action?addProfile=',
  messageChannelProfileActionDeleteProfile : 'message/MessageChannelProfile.action?deleteProfile=',
  messageChannelProfileActionMoveProfile : 'message/MessageChannelProfile.action?moveProfile=',
  messageChannelProfileActionUpdateProfile : 'message/MessageChannelProfile.action?updateProfile=',
  messageChannelProfileActionSendTestMessage : 'message/MessageChannelProfile.action?sendTestMessage=',

  messageChannelProfileActionAddFolder : 'message/MessageChannelProfile.action?addFolder=',
  messageChannelProfileActionDeleteFolder : 'message/MessageChannelProfile.action?deleteFolder=',
  messageChannelProfileActionMoveFolder : 'message/MessageChannelProfile.action?moveFolder=',
  messageChannelProfileActionUpdateFolder : 'message/MessageChannelProfile.action?updateFolder=',

  snmpGenerateMib : 'message/Snmp.action?generateMib=',


  /*
   * Scheduler actions
   */
  schedulerActionStart : 'scheduler/Scheduler.action?start=',
  schedulerActionPause : 'scheduler/Scheduler.action?pause=',
  schedulerActionStop : 'scheduler/Scheduler.action?stop=',

  schedulerActionDiscover : 'scheduler/Scheduler.action?discover=',
  schedulerActionTestConnection : 'scheduler/Scheduler.action?testConnection=',
  schedulerActionTestConnectionData : 'scheduler/Scheduler.action?testConnectionData=',

  schedulerActionAgentInfo : 'scheduler/Scheduler.action?agentInfo=',
  schedulerActionInfo : 'scheduler/Scheduler.action?schedulerInfo=',


  /*
   * Security actions
   */
  securityChangePassword : 'security/Security.action?changePassword=',
  securityLoginAction : 'security/Security.action?login=',
  securityLogoutAction : 'security/Security.action?logout=',
  securityRecoverUsername : 'security/Security.action?recoverUsername=',
  securityResetPasswordInit : 'security/Security.action?resetPasswordInit=',
  securityResetPasswordFinish : 'security/Security.action?resetPasswordFinish=',


  expressionActionValidate :  'expression/Expression.action?validate',


  /*
   * Quartz scheduler actions
   */
  quartz : {
    calendarActionList : 'scheduler/quartz/Calendar.action?list=',

    infoActionInfo : 'scheduler/quartz/Info.action?info=',

    /*
     * Job actions
     */
    jobActionList : 'scheduler/quartz/Job.action?list=',
    jobActionTrigger : 'scheduler/quartz/Job.action?trigger=',
    jobActionAdd : 'scheduler/quartz/Job.action?add=',
    jobActionUpdate : 'scheduler/quartz/Job.action?update=',
    jobActionDelete : 'scheduler/quartz/Job.action?delete=',
    jobActionInterrupt : 'scheduler/quartz/Job.action?interrupt=',
    jobActionListNextFireTimes : 'scheduler/quartz/Job.action?listNextFireTimes=',

    jobActionListExecuting : 'scheduler/quartz/Job.action?listExecuting=',
    jobActionGetThreadInfo : 'scheduler/quartz/Job.action?getThreadInfo=',
    jobActionListAvailableJobClasses : 'scheduler/quartz/Job.action?listAvailableJobClasses=',
    jobActionListPlannedJobExecutions : 'scheduler/quartz/Job.action?listPlannedJobExecutions=',

    jobGroupActionList : 'scheduler/quartz/JobGroup.action?list=',
    jobGroupActionResume : 'scheduler/quartz/JobGroup.action?resume=',
    jobGroupActionPause : 'scheduler/quartz/JobGroup.action?pause=',

    /*
     * Trigger actions
     */
    triggerActionListForJob : 'scheduler/quartz/Trigger.action?listForJob=',
    triggerActionList : 'scheduler/quartz/Trigger.action?list=',
    triggerActionResume : 'scheduler/quartz/Trigger.action?resume=',
    triggerActionPause : 'scheduler/quartz/Trigger.action?pause=',
    triggerActionAdd : 'scheduler/quartz/Trigger.action?add=',
    triggerActionUpdate : 'scheduler/quartz/Trigger.action?update=',
    triggerActionDelete : 'scheduler/quartz/Trigger.action?delete=',
    triggerActionListNextFireTimes : 'scheduler/quartz/Trigger.action?listNextFireTimes=',
    triggerActionListNextFireTimes2 : 'scheduler/quartz/Trigger.action?listNextFireTimes2=',

    triggerGroupActionList : 'scheduler/quartz/TriggerGroup.action?list=',
    triggerGroupActionListForJob : 'scheduler/quartz/TriggerGroup.action?listForJob=',
    triggerGroupActionResume : 'scheduler/quartz/TriggerGroup.action?resume=',
    triggerGroupActionPause : 'scheduler/quartz/TriggerGroup.action?pause=',

    /*
     * Misfired trigger actions
     */
    misfiredTriggerActionListForScheduler : 'scheduler/quartz/MisfiredTrigger.action?listForScheduler=',
    misfiredTriggerActionListForJob : 'scheduler/quartz/MisfiredTrigger.action?listForJob=',
    misfiredTriggerActionListForTrigger : 'scheduler/quartz/MisfiredTrigger.action?listForTrigger=',

    /*
     * Execution history actions
     */
    execHistoryActionListForScheduler : 'scheduler/quartz/ExecHistory.action?listForScheduler=',
    execHistoryActionListForJob : 'scheduler/quartz/ExecHistory.action?listForJob=',
    execHistoryActionListForTrigger : 'scheduler/quartz/ExecHistory.action?listForTrigger=',

    execHistoryActionResult : 'scheduler/quartz/ExecHistory.action?result=',
    execHistoryActionUserData : 'scheduler/quartz/ExecHistory.action?userData=',

    execHistoryActionExecutingJobLog : 'scheduler/quartz/ExecHistory.action?executingJobLog=',
    execHistoryActionExecutingJobLogSave : 'scheduler/quartz/ExecHistory.action?executingJobLogSave=',
    execHistoryActionExecutingJobLogDownload : 'scheduler/quartz/ExecHistory.action?executingJobLogDownload=',

    execHistoryActionExportForScheduler : 'scheduler/quartz/ExecHistory.action?exportForScheduler=',
    execHistoryActionExportForJob : 'scheduler/quartz/ExecHistory.action?exportForJob=',
    execHistoryActionExportForTrigger : 'scheduler/quartz/ExecHistory.action?exportForTrigger=',
    execHistoryActionExportDownload : 'scheduler/quartz/ExecHistory.action?exportDownload=',

    execHistoryActionLog : 'scheduler/quartz/ExecHistory.action?log=',
    execHistoryActionLogSave : 'scheduler/quartz/ExecHistory.action?logSave=',
    execHistoryActionLogDownload : 'scheduler/quartz/ExecHistory.action?logDownload=',

    /*
     * Execution notification rule actions
     */
    execNotificationRuleActionListForScheduler : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?listForScheduler=',
    execNotificationRuleActionListForJob : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?listForJob=',
    execNotificationRuleActionListForTrigger : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?listForTrigger=',
    execNotificationRuleActionGet : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?get=',
    execNotificationRuleActionAdd : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?add=',
    execNotificationRuleActionUpdate : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?update=',
    execNotificationRuleActionDelete : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?delete=',

    execNotificationRuleActionEnable : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?enable=',
    execNotificationRuleActionDisable : 'scheduler/quartz/notif/exec/ExecNotificationRule.action?disable=',

    execNotificationRuleSendTestMessageActionTest : 'scheduler/quartz/notif/exec/SendTestMessage.action?test=',

    /*
     * Statistics actions
     */
    jobStatisticsActionListPeriods : 'scheduler/quartz/stats/JobStatistics.action?listPeriods=',
    jobStatisticsActionChartData : 'scheduler/quartz/stats/JobStatistics.action?chartData=',

    triggerStatisticsActionListPeriods : 'scheduler/quartz/stats/TriggerStatistics.action?listPeriods=',
    triggerStatisticsActionChartData : 'scheduler/quartz/stats/TriggerStatistics.action?chartData=',

    schedulerStatisticsActionListPeriods : 'scheduler/quartz/stats/SchedulerStatistics.action?listPeriods=',
    schedulerStatisticsActionChartData : 'scheduler/quartz/stats/SchedulerStatistics.action?chartData=',

    /*
     * Job chain actions
     */
    jobChainActionListForScheduler : 'scheduler/quartz/chain/JobChain.action?listForScheduler=',
    jobChainActionListForJob : 'scheduler/quartz/chain/JobChain.action?listForJob=',
    jobChainActionListForTrigger : 'scheduler/quartz/chain/JobChain.action?listForTrigger=',
    jobChainActionGet : 'scheduler/quartz/chain/JobChain.action?get=',
    jobChainActionAdd : 'scheduler/quartz/chain/JobChain.action?add=',
    jobChainActionUpdate : 'scheduler/quartz/chain/JobChain.action?update=',
    jobChainActionDelete : 'scheduler/quartz/chain/JobChain.action?delete=',

    jobChainActionEnable : 'scheduler/quartz/chain/JobChain.action?enable=',
    jobChainActionDisable : 'scheduler/quartz/chain/JobChain.action?disable='
  }
} );
